<template>
  <div>
    <q-table
      card-class="super-rounded-borders"
      table-header-class="text-grey"
      :pagination.sync="pagination"
      :loading="loading"
      :columns="columns"
      :data="tableData"
      :filter="filter"
      color="primary"
      row-key="id"
      bordered
      dense
      flat
      @row-click="(e, { id }) => $router.push(`/composing/${id}`)"
    >
      <template v-slot:top-left>
        <div
          class="text-h6 text-accent q-pa-md"
          v-text="title"
        />
      </template>

      <template v-slot:top-right>
        <q-input
          v-model="filter"
          class="q-py-md q-px-xs"
          placeholder="Buscar"
          color="primary"
          debounce="300"
          outlined
          dense
        >
          <template v-slot:append>
            <q-icon name="search" />
          </template>
        </q-input>
      </template>

      <template v-slot:body-cell-action="props">
        <q-td :props="props">
          <q-btn
            :to="`/composing/${props.row.id}`"
            icon="fas fa-eye"
            color="primary"
            size="sm"
            round
            dense
            flat
          />
        </q-td>
      </template>
    </q-table>
  </div>
</template>

<script>
export default {
  name: 'TableView',
  props: {
    columns: {
      type: Array,
      required: true
    },
    tableData: {
      type: Array,
      required: true
    },
    title: {
      type: String,
      default: () => ('')
    },
    sortBy: {
      type: String,
      required: true
    }
  },
  data () {
    return {
      pagination: {
        sortBy: this.sortBy,
        descending: true,
        rowsPerPage: 15,
        page: 1
      },
      loading: false,
      filter: ''
    }
  }
}
</script>
